package skyjed.gui;

import java.awt.FlowLayout;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JPanel;

import skyjed.gui.action.ManagePokemonQAction;
import skyjed.gui.util.GBConstraints;
import skyjed.gui.util.GBLayout;
import skyjed.gui.util.GBPanel;
import skyjed.save.QuickSaveSlot;

public class QuickSaveEditPanel extends GBPanel {

    private QuickSaveSlot qSaveSlot;

    private Action openPokemonQAction;

    /**
     * Create the panel.
     */
    public QuickSaveEditPanel(QuickSaveSlot qSave) {
        qSaveSlot = qSave;
        openPokemonQAction = new ManagePokemonQAction("Pokemon", qSaveSlot.pkmnQStorage.pkmns);
        initialize();
    }

    /**
     * Initialize the contents of the frame.
     */
    private void initialize() {
        setSize(470, 280);
        {
            GBLayout gbl = new GBLayout();
            gbl.columnWidths(10, 0, 0, 0, 0, 0, 0);
            gbl.rowHeights(0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
            gbl.columnWeights(0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
            gbl.rowWeights(0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0);
            setLayout(gbl);
        }
        {
            JPanel buttonPane = new JPanel();
            FlowLayout flowLayout = (FlowLayout) buttonPane.getLayout();
            flowLayout.setAlignment(FlowLayout.RIGHT);
            add(buttonPane, new GBConstraints(1, 9, 6, 1).fillBoth());

            buttonPane.add(new JButton(openPokemonQAction));
        }
    }

    public QuickSaveSlot getSave() {
        return qSaveSlot;
    }

}
