package skyjed.gui.util;

import java.awt.GridBagConstraints;
import java.awt.Insets;

public class GBConstraints extends GridBagConstraints {

    public static final int AUTOMATIC = -1;

    private GBConstraints() {
        insets = new Insets(AUTOMATIC, AUTOMATIC, AUTOMATIC, AUTOMATIC);
    }

    public GBConstraints(int gridx, int gridy) {
        this();
        this.gridx = gridx;
        this.gridy = gridy;
    }

    public GBConstraints(int gridx, int gridy, int gridwidth, int gridheight) {
        this(gridx, gridy);
        this.gridwidth = gridwidth;
        this.gridheight = gridheight;
    }

    public GBConstraints anchorNorth() {
        anchor = GridBagConstraints.NORTH;
        return this;
    }

    public GBConstraints anchorEast() {
        anchor = GridBagConstraints.EAST;
        return this;
    }

    public GBConstraints anchorSouth() {
        anchor = GridBagConstraints.SOUTH;
        return this;
    }

    public GBConstraints anchorWest() {
        anchor = GridBagConstraints.WEST;
        return this;
    }

    public GBConstraints fillHorizontal() {
        fill = GridBagConstraints.HORIZONTAL;
        return this;
    }

    public GBConstraints fillVertical() {
        fill = GridBagConstraints.VERTICAL;
        return this;
    }

    public GBConstraints fillBoth() {
        fill = GridBagConstraints.BOTH;
        return this;
    }

    public GBConstraints insetT(int value) {
        insets.top = value;
        return this;
    }

    public GBConstraints insetL(int value) {
        insets.left = value;
        return this;
    }

    public GBConstraints insetB(int value) {
        insets.bottom = value;
        return this;
    }

    public GBConstraints insetR(int value) {
        insets.right = value;
        return this;
    }

}
