package skyjed.gui.util;

import java.awt.*;

import javax.swing.JPanel;

public class GBPanel extends JPanel {

    private int layoutWidth;
    private int layoutHeight;

    public GBPanel() {
        updateDimensions();
    }

    public GBPanel(GridBagLayout layout) {
        super(layout);
        updateDimensions();
    }

    public void setLayout(LayoutManager layout) {
        super.setLayout(layout);
        updateDimensions();
    }

    public void add(Component comp, Object constraints) {
        GridBagConstraints gbc = (GridBagConstraints) constraints;
        int endx = gbc.gridwidth == GridBagConstraints.REMAINDER ? layoutWidth : gbc.gridx + gbc.gridwidth;
        int endy = gbc.gridheight == GridBagConstraints.REMAINDER ? layoutHeight : gbc.gridy + gbc.gridheight;
        if(endx > layoutWidth || endy > layoutHeight) {
            System.err.println("DEBUG: layout bounds exceeded");
            //throw(new RuntimeException("DEBUG: layout bounds exceeded"));
        }
        boolean b_right = endx == layoutWidth;
        boolean b_bottom = endy == layoutHeight;
        if(gbc.insets.top == GBConstraints.AUTOMATIC) gbc.insets.top = 0;
        if(gbc.insets.left == GBConstraints.AUTOMATIC) gbc.insets.left = 0;
        if(gbc.insets.bottom == GBConstraints.AUTOMATIC) gbc.insets.bottom = b_bottom?0:5;
        if(gbc.insets.right == GBConstraints.AUTOMATIC) gbc.insets.right = b_right?0:5;
        super.add(comp, gbc);
    }

    private void updateDimensions() {
        LayoutManager layout = getLayout();
        if(!GridBagLayout.class.isInstance(layout)) {
            layoutWidth = layoutHeight = -1;
            return;
        }
        GridBagLayout gbl = (GridBagLayout) layout;
        layoutWidth = gbl.columnWidths.length;
        layoutHeight = gbl.rowHeights.length;
    }

}
