package skyjed.gui.util;

import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.*;

public class JSkyTextField extends JTextField {

    private int limit;

    public JSkyTextField(int limit) {
        super();
        this.limit = limit;
    }

    protected Document createDefaultModel() {
        return new SkyDocumentModel();
    }

    private class SkyDocumentModel extends PlainDocument {
        public SkyDocumentModel() {
            addDocumentListener(new DocumentListener() {
                @Override
                public void removeUpdate(DocumentEvent ev) {
                    globalUpdate(ev);
                }
                @Override
                public void insertUpdate(DocumentEvent ev) {
                    globalUpdate(ev);
                }
                @Override
                public void changedUpdate(DocumentEvent ev) {
                    globalUpdate(ev);
                }
                private void globalUpdate(DocumentEvent ev) {
                    System.out.println("update: " + ((SkyDocumentModel) ev.getDocument()).getText());
                    // TODO
                }
            });
        }

        public void insertString(int offset, String str, AttributeSet attr) throws BadLocationException {
            if(str == null) return;
            if(getLength() + str.length() <= limit) {
                super.insertString(offset, str, attr);
            }
        }

        public String getText() {
            try {
                return getText(0, getLength());
            } catch(BadLocationException e) {
                // shouldn't happen
                e.printStackTrace();
                return "";
            }
        }
    }

}
