package skyjed.util;

import java.util.Arrays;

import skyjed.resources.SkyCharsetRes;

public class SkyCharConv {

    private static final int NAME_LENGTH = 10;

    public static SkyStringTrash decode(byte[] buf) {
        char[] tmp = new char[NAME_LENGTH];
        for(int i=0; i<buf.length; i++) {
            if(buf[i] == 0) {
                return new SkyStringTrash(ArrayUtils.copyFrom(tmp, 0, i), Arrays.copyOfRange(buf, i+1, NAME_LENGTH));
            }
            tmp[i] = SkyCharsetRes.byte2char(buf[i]);
        }
        return new SkyStringTrash(tmp);
    }

    public static byte[] encode(SkyStringTrash str) {
        byte[] buf = new byte[NAME_LENGTH];
        for(int i=0; i<str.length(); i++) {
            buf[i] = SkyCharsetRes.char2byte(str.charAt(i));
        }
        if(str.length() < NAME_LENGTH) {
            // trash bytes
            for(int i=str.length()+1, j=0; i<NAME_LENGTH && j<str.getTrash().length; i++, j++) {
                buf[i] = str.getTrash()[j];
            }
        }
        return buf;
    }

}
