package skyjed.util;

public class SkyStringTrash implements CharSequence {

    private String string;
    private byte[] trash;

    public SkyStringTrash(String string, byte[] trash) {
        this.string = string;
        this.trash = trash;
    }

    public SkyStringTrash(String string) {
        this(string, new byte[0]);
    }

    public SkyStringTrash() {
        this("");
    }

    public SkyStringTrash(char[] chars, byte[] trash) {
        this(new String(chars), trash);
    }

    public SkyStringTrash(char[] chars) {
        this(chars, new byte[0]);
    }

    @Override
    public char charAt(int index) {
        return string.charAt(index);
    }

    @Override
    public int length() {
        return string.length();
    }

    @Override
    public CharSequence subSequence(int start, int end) {
        return string.subSequence(start, end);
    }

    @Override
    public String toString() {
        return string;
    }

    public final String getString() {
        return string;
    }

    public final void setString(String string) {
        this.string = string;
    }

    public final byte[] getTrash() {
        return trash;
    }

    public final void setTrash(byte[] trash) {
        this.trash = trash;
    }

}
